//This file is generated by TAU's proxygenerator 
// The command line used to generate it was: 
// ./tau_pg -c integrators::ccaports::Integrator -t integrators.ccaports.Integrator -p IntegratorPort -d ParallelIntegrator_CCA.pdb -h ports/Integrator_CCA.h -o IntegratorMonitorProxy.cc -n IntegratorMonitorProxy -m 

#include <iostream> 
#include "cca.h" 
#include "ports/Monitor_CCA.h" 
#include "ports/Integrator_CCA.h" 
#include <unistd.h> 
using namespace std; 

#define TAU_COMP_NAME1 integrators::ccaports::Integrator
#define TAU_COMP_NAME2 "integrators.ccaports.Integrator" 
namespace TAU1 
{ 
  namespace TAU2
  { 
    class IntegratorMonitorProxy : public virtual TAU_COMP_NAME1, 
      public virtual classic::gov::cca::Component 
      { 
        public:  
		 
	~IntegratorMonitorProxy(void);
	double	integrate(double lowBound,double upBound,int count);
	virtual void setServices(classic::gov::cca::Services *services); 
	private: 
	  classic::gov::cca::Services   * frameworkServices; 
      }; 
IntegratorMonitorProxy::~IntegratorMonitorProxy(void)
{
}
double IntegratorMonitorProxy::integrate( double lowBound , double upBound , int count )
{
  classic::gov::cca::Port *port; 
  // Get proxy port 
  TAU_COMP_NAME1 *proxy; 
  port = frameworkServices->getPort("IntegratorPortUse");
  if (port) 
    proxy = dynamic_cast < TAU_COMP_NAME1 * > (port);  
  if (proxy == 0) 
  { 
    cerr <<"Connected to something other than aIntegratorPort port"<< endl; 
  } 
  // Get a Monitor port 
  port = frameworkServices->getPort("MonitorPort");
  monitor::ccaports::Monitor *monitor; 
  if (port) 
    monitor = dynamic_cast < monitor::ccaports::Monitor * >(port); 
  if (monitor == 0) { 
    std::cerr <<"Connected to something other than a Monitor port"<<endl; 
  } 
  classic::gov::cca::ComponentID *cid = frameworkServices->getComponentID(); 
  string tau_name = cid->toString(); 
  tau_name+="::integrate( double, double, int)";
  map<string,double> tau_params; 
  tau_params.insert(make_pair("lowBound", lowBound));
  tau_params.insert(make_pair("upBound", upBound));
  tau_params.insert(make_pair("count", count));
  monitor->createRecord(tau_name);
  monitor->startMonitoring(tau_name, tau_params);
  double result = proxy->integrate(lowBound,upBound,count); 
  monitor->stopMonitoring(tau_name); 
  // Releasing ports  
  frameworkServices->releasePort("MonitorPort"); 
  frameworkServices->releasePort("IntegratorPortUse"); 
  return result; 
}
void IntegratorMonitorProxy::setServices (classic::gov::cca::Services *services)
{
  if (services != 0) 
  {  
    frameworkServices = services; 
    classic::gov::cca::PortInfo * portInfo =  
      frameworkServices->createPortInfo ("IntegratorPortProvide", TAU_COMP_NAME2, 0); 
    if (portInfo != 0) 
      frameworkServices->addProvidesPort(this, portInfo); 

    portInfo = frameworkServices->createPortInfo("IntegratorPortUse", TAU_COMP_NAME2, 0); 
    frameworkServices->registerUsesPort(portInfo); 
    // Use a monitor Port 
    portInfo = frameworkServices->createPortInfo("MonitorPort",
      "monitor.ccaports.Monitor", 0); 
    frameworkServices->registerUsesPort(portInfo); 
  }
  else 
  { 
    // Close down services if not closed already 
    if (frameworkServices != 0) 
      frameworkServices->removeProvidesPort("IntegratorPortProvide"); 
    frameworkServices = 0; 
  } /* end of if */
} /* end of setServices */
  } /* namespace TAU2 */
} /* namespace TAU1 */


/* C wrappers for the component */
extern "C" 
{ 
  classic::gov::cca::Component *createIntegratorMonitorProxy() 
  { 
    classic::gov::cca::Component *wrapper;  
    TAU1::TAU2::IntegratorMonitorProxy * component; 
    component = new TAU1::TAU2::IntegratorMonitorProxy(); 
    wrapper = dynamic_cast < classic::gov::cca::Component *> (component); 
    return wrapper; 
  } 
  char **getComponentList() 
  {
    static char *list[2]; 
    list[0] = "createIntegratorMonitorProxy IntegratorMonitorProxy"; 
    list[1] = 0; 
    return list; 
  } 
}; /* extern C */ 
